Index: trunk/src/org/openstreetmap/josm/gui/layer/WMSLayer.java
===================================================================
--- trunk/src/org/openstreetmap/josm/gui/layer/WMSLayer.java	(revision 8307)
+++ trunk/src/org/openstreetmap/josm/gui/layer/WMSLayer.java	(revision 8308)
@@ -128,6 +128,6 @@
     protected boolean autoResolutionEnabled = PROP_DEFAULT_AUTOZOOM.get();
     protected boolean settingsChanged;
-    public WmsCache cache;
-    private AttributionSupport attribution = new AttributionSupport();
+    public transient WmsCache cache;
+    private transient AttributionSupport attribution = new AttributionSupport();
 
     // Image index boundary for current view
@@ -140,14 +140,14 @@
 
     // Request queue
-    private final List<WMSRequest> requestQueue = new ArrayList<>();
-    private final List<WMSRequest> finishedRequests = new ArrayList<>();
+    private final transient List<WMSRequest> requestQueue = new ArrayList<>();
+    private final transient List<WMSRequest> finishedRequests = new ArrayList<>();
     /**
      * List of request currently being processed by download threads
      */
-    private final List<WMSRequest> processingRequests = new ArrayList<>();
-    private final Lock requestQueueLock = new ReentrantLock();
-    private final Condition queueEmpty = requestQueueLock.newCondition();
-    private final List<WMSGrabber> grabbers = new ArrayList<>();
-    private final List<Thread> grabberThreads = new ArrayList<>();
+    private final transient List<WMSRequest> processingRequests = new ArrayList<>();
+    private final transient Lock requestQueueLock = new ReentrantLock();
+    private final transient Condition queueEmpty = requestQueueLock.newCondition();
+    private final transient List<WMSGrabber> grabbers = new ArrayList<>();
+    private final transient List<Thread> grabberThreads = new ArrayList<>();
     private boolean canceled;
 
Index: trunk/src/org/openstreetmap/josm/gui/layer/geoimage/CorrelateGpxWithImages.java
===================================================================
--- trunk/src/org/openstreetmap/josm/gui/layer/geoimage/CorrelateGpxWithImages.java	(revision 8307)
+++ trunk/src/org/openstreetmap/josm/gui/layer/geoimage/CorrelateGpxWithImages.java	(revision 8308)
@@ -91,5 +91,5 @@
     private static List<GpxData> loadedGpxData = new ArrayList<>();
 
-    private GeoImageLayer yLayer = null;
+    private transient GeoImageLayer yLayer = null;
     private double timezone;
     private long delta;
@@ -122,5 +122,5 @@
 
     private ExtendedDialog syncDialog;
-    private List<GpxDataWrapper> gpxLst = new ArrayList<>();
+    private transient List<GpxDataWrapper> gpxLst = new ArrayList<>();
     private JPanel outerPanel;
     private JosmComboBox<GpxDataWrapper> cbGpx;
@@ -764,6 +764,6 @@
     }
 
-    private StatusBarUpdater statusBarUpdater = new StatusBarUpdater(false);
-    private StatusBarUpdater statusBarUpdaterWithRepaint = new StatusBarUpdater(true);
+    private transient StatusBarUpdater statusBarUpdater = new StatusBarUpdater(false);
+    private transient StatusBarUpdater statusBarUpdaterWithRepaint = new StatusBarUpdater(true);
 
     private class StatusBarUpdater implements  DocumentListener, ItemListener, ActionListener {
@@ -835,5 +835,5 @@
     }
 
-    private RepaintTheMapListener repaintTheMap = new RepaintTheMapListener();
+    private transient RepaintTheMapListener repaintTheMap = new RepaintTheMapListener();
     private class RepaintTheMapListener implements FocusListener {
         @Override
Index: trunk/src/org/openstreetmap/josm/gui/layer/geoimage/ImageDisplay.java
===================================================================
--- trunk/src/org/openstreetmap/josm/gui/layer/geoimage/ImageDisplay.java	(revision 8307)
+++ trunk/src/org/openstreetmap/josm/gui/layer/geoimage/ImageDisplay.java	(revision 8308)
@@ -35,5 +35,5 @@
 
     /** The image currently displayed */
-    private Image image = null;
+    private transient Image image = null;
 
     /** The image currently displayed */
Index: trunk/src/org/openstreetmap/josm/gui/layer/geoimage/ImageViewerDialog.java
===================================================================
--- trunk/src/org/openstreetmap/josm/gui/layer/geoimage/ImageViewerDialog.java	(revision 8307)
+++ trunk/src/org/openstreetmap/josm/gui/layer/geoimage/ImageViewerDialog.java	(revision 8308)
@@ -274,6 +274,6 @@
     }
 
-    private GeoImageLayer currentLayer = null;
-    private ImageEntry currentEntry = null;
+    private transient GeoImageLayer currentLayer = null;
+    private transient ImageEntry currentEntry = null;
 
     public void displayImage(GeoImageLayer layer, ImageEntry entry) {
Index: trunk/src/org/openstreetmap/josm/gui/layer/geoimage/ShowThumbnailAction.java
===================================================================
--- trunk/src/org/openstreetmap/josm/gui/layer/geoimage/ShowThumbnailAction.java	(revision 8307)
+++ trunk/src/org/openstreetmap/josm/gui/layer/geoimage/ShowThumbnailAction.java	(revision 8308)
@@ -7,4 +7,5 @@
 import java.awt.event.ActionEvent;
 import java.util.List;
+
 import javax.swing.AbstractAction;
 import javax.swing.JCheckBoxMenuItem;
@@ -21,5 +22,5 @@
 public class ShowThumbnailAction extends AbstractAction implements LayerAction {
 
-    private final GeoImageLayer layer;
+    private final transient GeoImageLayer layer;
 
     /**
Index: trunk/src/org/openstreetmap/josm/gui/layer/gpx/ChooseTrackVisibilityAction.java
===================================================================
--- trunk/src/org/openstreetmap/josm/gui/layer/gpx/ChooseTrackVisibilityAction.java	(revision 8307)
+++ trunk/src/org/openstreetmap/josm/gui/layer/gpx/ChooseTrackVisibilityAction.java	(revision 8308)
@@ -13,4 +13,5 @@
 import java.awt.event.MouseEvent;
 import java.awt.event.MouseListener;
+import java.io.Serializable;
 import java.util.Arrays;
 import java.util.Comparator;
@@ -47,5 +48,5 @@
  */
 public class ChooseTrackVisibilityAction extends AbstractAction {
-    private final GpxLayer layer;
+    private final transient GpxLayer layer;
 
     private DateFilterPanel dateFilter;
@@ -89,5 +90,7 @@
      * Comparator for TrackLength objects
      */
-    private static final class LengthContentComparator implements Comparator<TrackLength> {
+    private static final class LengthContentComparator implements Comparator<TrackLength>, Serializable {
+
+        private static final long serialVersionUID = 1L;
 
         /**
Index: trunk/src/org/openstreetmap/josm/gui/layer/gpx/ConvertToDataLayerAction.java
===================================================================
--- trunk/src/org/openstreetmap/josm/gui/layer/gpx/ConvertToDataLayerAction.java	(revision 8307)
+++ trunk/src/org/openstreetmap/josm/gui/layer/gpx/ConvertToDataLayerAction.java	(revision 8308)
@@ -32,5 +32,5 @@
 
 public class ConvertToDataLayerAction extends AbstractAction {
-    private final GpxLayer layer;
+    private final transient GpxLayer layer;
 
     public ConvertToDataLayerAction(final GpxLayer layer) {
Index: trunk/src/org/openstreetmap/josm/gui/layer/gpx/CustomizeDrawingAction.java
===================================================================
--- trunk/src/org/openstreetmap/josm/gui/layer/gpx/CustomizeDrawingAction.java	(revision 8307)
+++ trunk/src/org/openstreetmap/josm/gui/layer/gpx/CustomizeDrawingAction.java	(revision 8308)
@@ -29,5 +29,5 @@
 
 public class CustomizeDrawingAction extends AbstractAction implements LayerAction, MultiLayerAction {
-    private List<Layer> layers;
+    private transient List<Layer> layers;
 
     public CustomizeDrawingAction(List<Layer> l) {
Index: trunk/src/org/openstreetmap/josm/gui/layer/gpx/DateFilterPanel.java
===================================================================
--- trunk/src/org/openstreetmap/josm/gui/layer/gpx/DateFilterPanel.java	(revision 8307)
+++ trunk/src/org/openstreetmap/josm/gui/layer/gpx/DateFilterPanel.java	(revision 8308)
@@ -26,7 +26,7 @@
     private DateEditorWithSlider dateTo = new DateEditorWithSlider(tr("To"));
     private JCheckBox noTimestampCb  = new JCheckBox(tr("No timestamp"));
-    private GpxLayer layer;
+    private transient GpxLayer layer;
 
-    private ActionListener filterAppliedListener;
+    private transient ActionListener filterAppliedListener;
 
     private final String PREF_DATE_0;
@@ -67,5 +67,5 @@
     }
 
-    private ChangeListener changeListener = new ChangeListener() {
+    private transient ChangeListener changeListener = new ChangeListener() {
         @Override public void stateChanged(ChangeEvent e) {
             if (isEnabled()) applyFilterWithDelay();
Index: trunk/src/org/openstreetmap/josm/gui/layer/gpx/DownloadAlongTrackAction.java
===================================================================
--- trunk/src/org/openstreetmap/josm/gui/layer/gpx/DownloadAlongTrackAction.java	(revision 8307)
+++ trunk/src/org/openstreetmap/josm/gui/layer/gpx/DownloadAlongTrackAction.java	(revision 8308)
@@ -37,5 +37,5 @@
     private static final String PREF_DOWNLOAD_ALONG_TRACK_NEAR = "downloadAlongTrack.near";
 
-    private final GpxData data;
+    private final transient GpxData data;
 
     /**
Index: trunk/src/org/openstreetmap/josm/gui/layer/gpx/DownloadWmsAlongTrackAction.java
===================================================================
--- trunk/src/org/openstreetmap/josm/gui/layer/gpx/DownloadWmsAlongTrackAction.java	(revision 8307)
+++ trunk/src/org/openstreetmap/josm/gui/layer/gpx/DownloadWmsAlongTrackAction.java	(revision 8308)
@@ -37,5 +37,5 @@
 public class DownloadWmsAlongTrackAction extends AbstractAction {
 
-    private final GpxData data;
+    private final transient GpxData data;
 
     public DownloadWmsAlongTrackAction(final GpxData data) {
Index: trunk/src/org/openstreetmap/josm/gui/layer/gpx/ImportAudioAction.java
===================================================================
--- trunk/src/org/openstreetmap/josm/gui/layer/gpx/ImportAudioAction.java	(revision 8307)
+++ trunk/src/org/openstreetmap/josm/gui/layer/gpx/ImportAudioAction.java	(revision 8308)
@@ -40,5 +40,5 @@
  */
 public class ImportAudioAction extends AbstractAction {
-    private final GpxLayer layer;
+    private final transient GpxLayer layer;
 
     private static class Markers {
Index: trunk/src/org/openstreetmap/josm/gui/layer/gpx/ImportImagesAction.java
===================================================================
--- trunk/src/org/openstreetmap/josm/gui/layer/gpx/ImportImagesAction.java	(revision 8307)
+++ trunk/src/org/openstreetmap/josm/gui/layer/gpx/ImportImagesAction.java	(revision 8308)
@@ -24,5 +24,5 @@
 
 public class ImportImagesAction extends AbstractAction {
-    private final GpxLayer layer;
+    private final transient GpxLayer layer;
 
     public ImportImagesAction(final GpxLayer layer) {
Index: trunk/src/org/openstreetmap/josm/gui/layer/gpx/MarkersFromNamedPointsAction.java
===================================================================
--- trunk/src/org/openstreetmap/josm/gui/layer/gpx/MarkersFromNamedPointsAction.java	(revision 8307)
+++ trunk/src/org/openstreetmap/josm/gui/layer/gpx/MarkersFromNamedPointsAction.java	(revision 8308)
@@ -19,5 +19,5 @@
 
 public class MarkersFromNamedPointsAction extends AbstractAction {
-    private final GpxLayer layer;
+    private final transient GpxLayer layer;
 
     public MarkersFromNamedPointsAction(final GpxLayer layer) {
Index: trunk/src/org/openstreetmap/josm/gui/layer/markerlayer/MarkerLayer.java
===================================================================
--- trunk/src/org/openstreetmap/josm/gui/layer/markerlayer/MarkerLayer.java	(revision 8307)
+++ trunk/src/org/openstreetmap/josm/gui/layer/markerlayer/MarkerLayer.java	(revision 8308)
@@ -468,5 +468,5 @@
 
     public static final class ShowHideMarkerText extends AbstractAction implements LayerAction {
-        private final MarkerLayer layer;
+        private final transient MarkerLayer layer;
 
         public ShowHideMarkerText(MarkerLayer layer) {
Index: trunk/src/org/openstreetmap/josm/gui/mappaint/MapPaintMenu.java
===================================================================
--- trunk/src/org/openstreetmap/josm/gui/mappaint/MapPaintMenu.java	(revision 8307)
+++ trunk/src/org/openstreetmap/josm/gui/mappaint/MapPaintMenu.java	(revision 8308)
@@ -30,5 +30,5 @@
     private static class MapPaintAction extends JosmAction {
 
-        private StyleSource style;
+        private transient StyleSource style;
         private JCheckBoxMenuItem button;
 
@@ -78,5 +78,5 @@
         }
     }
-    private final Map<String, MapPaintAction> actions = new HashMap<>();
+    private final transient Map<String, MapPaintAction> actions = new HashMap<>();
 
     /**
Index: trunk/src/org/openstreetmap/josm/gui/oauth/AbstractAuthorizationUI.java
===================================================================
--- trunk/src/org/openstreetmap/josm/gui/oauth/AbstractAuthorizationUI.java	(revision 8307)
+++ trunk/src/org/openstreetmap/josm/gui/oauth/AbstractAuthorizationUI.java	(revision 8308)
@@ -7,4 +7,6 @@
 import org.openstreetmap.josm.gui.widgets.VerticallyScrollablePanel;
 import org.openstreetmap.josm.tools.CheckParameterUtil;
+
+import com.sun.org.apache.xerces.internal.utils.Objects;
 
 /**
@@ -21,5 +23,5 @@
     private String apiUrl;
     private final AdvancedOAuthPropertiesPanel pnlAdvancedProperties;
-    private OAuthToken accessToken;
+    private transient OAuthToken accessToken;
 
     protected void fireAccessTokenChanged(OAuthToken oldValue, OAuthToken newValue) {
@@ -99,5 +101,5 @@
         } else if (oldValue == null && this.accessToken == null) {
             // no change - don't fire an event
-        } else if (! oldValue.equals(this.accessToken)) {
+        } else if (!Objects.equals(oldValue, this.accessToken)) {
             fireAccessTokenChanged(oldValue, this.accessToken);
         }
Index: trunk/src/org/openstreetmap/josm/gui/oauth/AdvancedOAuthPropertiesPanel.java
===================================================================
--- trunk/src/org/openstreetmap/josm/gui/oauth/AdvancedOAuthPropertiesPanel.java	(revision 8307)
+++ trunk/src/org/openstreetmap/josm/gui/oauth/AdvancedOAuthPropertiesPanel.java	(revision 8308)
@@ -48,5 +48,5 @@
     private JosmTextField tfAccessTokenURL;
     private JosmTextField tfAuthoriseURL;
-    private UseDefaultItemListener ilUseDefault;
+    private transient UseDefaultItemListener ilUseDefault;
     private String apiUrl;
 
Index: trunk/src/org/openstreetmap/josm/gui/oauth/FullyAutomaticAuthorizationUI.java
===================================================================
--- trunk/src/org/openstreetmap/josm/gui/oauth/FullyAutomaticAuthorizationUI.java	(revision 8307)
+++ trunk/src/org/openstreetmap/josm/gui/oauth/FullyAutomaticAuthorizationUI.java	(revision 8308)
@@ -60,6 +60,6 @@
     private JosmTextField tfUserName;
     private JosmPasswordField tfPassword;
-    private UserNameValidator valUserName;
-    private PasswordValidator valPassword;
+    private transient UserNameValidator valUserName;
+    private transient PasswordValidator valPassword;
     private AccessTokenInfoPanel pnlAccessTokenInfo;
     private OsmPrivilegesPanel pnlOsmPrivileges;
Index: trunk/src/org/openstreetmap/josm/gui/oauth/ManualAuthorizationUI.java
===================================================================
--- trunk/src/org/openstreetmap/josm/gui/oauth/ManualAuthorizationUI.java	(revision 8307)
+++ trunk/src/org/openstreetmap/josm/gui/oauth/ManualAuthorizationUI.java	(revision 8308)
@@ -42,7 +42,7 @@
 
     private JosmTextField tfAccessTokenKey;
-    private AccessTokenKeyValidator valAccessTokenKey;
+    private transient AccessTokenKeyValidator valAccessTokenKey;
     private JosmTextField tfAccessTokenSecret;
-    private AccessTokenSecretValidator valAccessTokenSecret;
+    private transient AccessTokenSecretValidator valAccessTokenSecret;
     private JCheckBox cbSaveToPreferences;
     private HtmlPanel pnlMessage;
Index: trunk/src/org/openstreetmap/josm/gui/oauth/OAuthAuthorizationWizard.java
===================================================================
--- trunk/src/org/openstreetmap/josm/gui/oauth/OAuthAuthorizationWizard.java	(revision 8307)
+++ trunk/src/org/openstreetmap/josm/gui/oauth/OAuthAuthorizationWizard.java	(revision 8308)
@@ -333,5 +333,5 @@
 
     class AcceptAccessTokenAction extends AbstractAction implements PropertyChangeListener {
-        private OAuthToken token;
+        private transient OAuthToken token;
 
         public AcceptAccessTokenAction() {
Index: trunk/src/org/openstreetmap/josm/gui/oauth/SemiAutomaticAuthorizationUI.java
===================================================================
--- trunk/src/org/openstreetmap/josm/gui/oauth/SemiAutomaticAuthorizationUI.java	(revision 8307)
+++ trunk/src/org/openstreetmap/josm/gui/oauth/SemiAutomaticAuthorizationUI.java	(revision 8308)
@@ -28,7 +28,7 @@
 import org.openstreetmap.josm.gui.widgets.HtmlPanel;
 import org.openstreetmap.josm.gui.widgets.JMultilineLabel;
+import org.openstreetmap.josm.gui.widgets.JosmTextField;
 import org.openstreetmap.josm.tools.ImageProvider;
 import org.openstreetmap.josm.tools.OpenBrowser;
-import org.openstreetmap.josm.gui.widgets.JosmTextField;
 
 /**
@@ -42,5 +42,5 @@
 public class SemiAutomaticAuthorizationUI extends AbstractAuthorizationUI {
     private AccessTokenInfoPanel pnlAccessTokenInfo;
-    private OAuthToken requestToken;
+    private transient OAuthToken requestToken;
 
     private RetrieveRequestTokenPanel pnlRetrieveRequestToken;
Index: trunk/src/org/openstreetmap/josm/gui/preferences/PreferenceTabbedPane.java
===================================================================
--- trunk/src/org/openstreetmap/josm/gui/preferences/PreferenceTabbedPane.java	(revision 8307)
+++ trunk/src/org/openstreetmap/josm/gui/preferences/PreferenceTabbedPane.java	(revision 8308)
@@ -92,5 +92,5 @@
 
     public static final class PreferencePanel extends JPanel implements PreferenceTab {
-        private final TabPreferenceSetting preferenceSetting;
+        private final transient TabPreferenceSetting preferenceSetting;
 
         private PreferencePanel(TabPreferenceSetting preferenceSetting) {
@@ -122,5 +122,5 @@
 
     public static final class PreferenceScrollPane extends JScrollPane implements PreferenceTab {
-        private final TabPreferenceSetting preferenceSetting;
+        private final transient TabPreferenceSetting preferenceSetting;
 
         private PreferenceScrollPane(Component view, TabPreferenceSetting preferenceSetting) {
@@ -145,13 +145,13 @@
 
     // all created tabs
-    private final List<PreferenceTab> tabs = new ArrayList<>();
+    private final transient List<PreferenceTab> tabs = new ArrayList<>();
     private static final Collection<PreferenceSettingFactory> settingsFactories = new LinkedList<>();
     private static final PreferenceSettingFactory advancedPreferenceFactory = new AdvancedPreference.Factory();
-    private final List<PreferenceSetting> settings = new ArrayList<>();
+    private final transient List<PreferenceSetting> settings = new ArrayList<>();
 
     // distinct list of tabs that have been initialized (we do not initialize tabs until they are displayed to speed up dialog startup)
-    private final List<PreferenceSetting> settingsInitialized = new ArrayList<>();
-
-    final List<ValidationListener> validationListeners = new ArrayList<>();
+    private final transient List<PreferenceSetting> settingsInitialized = new ArrayList<>();
+
+    final transient List<ValidationListener> validationListeners = new ArrayList<>();
 
     /**
Index: trunk/src/org/openstreetmap/josm/gui/preferences/SourceEditor.java
===================================================================
--- trunk/src/org/openstreetmap/josm/gui/preferences/SourceEditor.java	(revision 8307)
+++ trunk/src/org/openstreetmap/josm/gui/preferences/SourceEditor.java	(revision 8308)
@@ -111,5 +111,5 @@
     protected final AvailableSourcesListModel availableSourcesModel;
     protected final String availableSourcesUrl;
-    protected final List<SourceProvider> sourceProviders;
+    protected final transient List<SourceProvider> sourceProviders;
 
     protected JTable tblIconPaths;
@@ -447,5 +447,5 @@
 
     protected static class AvailableSourcesListModel extends DefaultListModel<ExtendedSourceEntry> {
-        private List<ExtendedSourceEntry> data;
+        private transient List<ExtendedSourceEntry> data;
         private DefaultListSelectionModel selectionModel;
 
@@ -499,5 +499,5 @@
 
     protected class ActiveSourcesModel extends AbstractTableModel {
-        private List<SourceEntry> data;
+        private transient List<SourceEntry> data;
         private DefaultListSelectionModel selectionModel;
 
@@ -1037,5 +1037,5 @@
     class ReloadSourcesAction extends AbstractAction {
         private final String url;
-        private final List<SourceProvider> sourceProviders;
+        private final transient List<SourceProvider> sourceProviders;
         public ReloadSourcesAction(String url, List<SourceProvider> sourceProviders) {
             putValue(NAME, tr("Reload"));
@@ -1055,5 +1055,5 @@
 
     protected static class IconPathTableModel extends AbstractTableModel {
-        private List<String> data;
+        private transient List<String> data;
         private DefaultListSelectionModel selectionModel;
 
@@ -1240,5 +1240,5 @@
     class SourceLoader extends PleaseWaitRunnable {
         private final String url;
-        private final List<SourceProvider> sourceProviders;
+        private final transient List<SourceProvider> sourceProviders;
         private BufferedReader reader;
         private boolean canceled;
Index: trunk/src/org/openstreetmap/josm/gui/preferences/ToolbarPreferences.java
===================================================================
--- trunk/src/org/openstreetmap/josm/gui/preferences/ToolbarPreferences.java	(revision 8307)
+++ trunk/src/org/openstreetmap/josm/gui/preferences/ToolbarPreferences.java	(revision 8308)
@@ -313,5 +313,5 @@
     private static class ActionParametersTableModel extends AbstractTableModel {
 
-        private ActionDefinition currentAction = ActionDefinition.getSeparator();
+        private transient ActionDefinition currentAction = ActionDefinition.getSeparator();
 
         @Override
@@ -393,5 +393,5 @@
 
     private class ToolbarPopupMenu extends JPopupMenu  {
-        private ActionDefinition act;
+        private transient ActionDefinition act;
 
         private void setActionAndAdapt(ActionDefinition action) {
Index: trunk/src/org/openstreetmap/josm/gui/preferences/advanced/AdvancedPreference.java
===================================================================
--- trunk/src/org/openstreetmap/josm/gui/preferences/advanced/AdvancedPreference.java	(revision 8307)
+++ trunk/src/org/openstreetmap/josm/gui/preferences/advanced/AdvancedPreference.java	(revision 8308)
@@ -357,27 +357,39 @@
             public void menuSelected(MenuEvent me) {
                 p.removeAll();
-                for (File f: new File(".").listFiles()) {
-                   String s = f.getName();
-                   int idx = s.indexOf('_');
-                   if (idx>=0) {
-                        String t=s.substring(0,idx);
-                        if (profileTypes.containsKey(t)) {
-                            p.add(new ImportProfileAction(s, f, t));
-                        }
-                   }
-                }
-                for (File f: Main.pref.getPreferencesDirectory().listFiles()) {
-                   String s = f.getName();
-                   int idx = s.indexOf('_');
-                   if (idx>=0) {
-                        String t=s.substring(0,idx);
-                        if (profileTypes.containsKey(t)) {
-                            p.add(new ImportProfileAction(s, f, t));
-                        }
-                   }
-                }
-            }
-            @Override public void menuDeselected(MenuEvent me) { }
-            @Override public void menuCanceled(MenuEvent me) { }
+                File[] files = new File(".").listFiles();
+                if (files != null) {
+                    for (File f: files) {
+                       String s = f.getName();
+                       int idx = s.indexOf('_');
+                       if (idx>=0) {
+                            String t=s.substring(0,idx);
+                            if (profileTypes.containsKey(t)) {
+                                p.add(new ImportProfileAction(s, f, t));
+                            }
+                       }
+                    }
+                }
+                files = Main.pref.getPreferencesDirectory().listFiles();
+                if (files != null) {
+                    for (File f: files) {
+                       String s = f.getName();
+                       int idx = s.indexOf('_');
+                       if (idx>=0) {
+                            String t=s.substring(0,idx);
+                            if (profileTypes.containsKey(t)) {
+                                p.add(new ImportProfileAction(s, f, t));
+                            }
+                       }
+                    }
+                }
+            }
+            @Override
+            public void menuDeselected(MenuEvent me) {
+                // Not implemented
+            }
+            @Override
+            public void menuCanceled(MenuEvent me) {
+                // Not implemented
+            }
         });
         return p;
Index: trunk/src/org/openstreetmap/josm/gui/preferences/advanced/ExportProfileAction.java
===================================================================
--- trunk/src/org/openstreetmap/josm/gui/preferences/advanced/ExportProfileAction.java	(revision 8307)
+++ trunk/src/org/openstreetmap/josm/gui/preferences/advanced/ExportProfileAction.java	(revision 8308)
@@ -28,5 +28,5 @@
     private final String prefPattern;
     private final String schemaKey;
-    private final Preferences prefs;
+    private final transient Preferences prefs;
 
     /**
Index: trunk/src/org/openstreetmap/josm/gui/preferences/advanced/ListEditor.java
===================================================================
--- trunk/src/org/openstreetmap/josm/gui/preferences/advanced/ListEditor.java	(revision 8307)
+++ trunk/src/org/openstreetmap/josm/gui/preferences/advanced/ListEditor.java	(revision 8308)
@@ -30,6 +30,6 @@
 public class ListEditor extends ExtendedDialog {
 
-    private List<String> data;
-    private PrefEntry entry;
+    private transient List<String> data;
+    private transient PrefEntry entry;
 
     /**
Index: trunk/src/org/openstreetmap/josm/gui/preferences/advanced/ListListEditor.java
===================================================================
--- trunk/src/org/openstreetmap/josm/gui/preferences/advanced/ListListEditor.java	(revision 8307)
+++ trunk/src/org/openstreetmap/josm/gui/preferences/advanced/ListListEditor.java	(revision 8308)
@@ -39,6 +39,6 @@
 
     private EntryListModel entryModel;
-    private List<List<String>> data;
-    private PrefEntry entry;
+    private transient List<List<String>> data;
+    private transient PrefEntry entry;
 
     private JList<String> entryList;
Index: trunk/src/org/openstreetmap/josm/gui/preferences/advanced/MapListEditor.java
===================================================================
--- trunk/src/org/openstreetmap/josm/gui/preferences/advanced/MapListEditor.java	(revision 8307)
+++ trunk/src/org/openstreetmap/josm/gui/preferences/advanced/MapListEditor.java	(revision 8308)
@@ -43,5 +43,5 @@
 
     private EntryListModel entryModel;
-    private PrefEntry entry;
+    private transient PrefEntry entry;
 
     private JList<String> entryList;
@@ -49,6 +49,6 @@
     private MapTableModel tableModel;
 
-    private List<List<String>> dataKeys;
-    private List<List<String>> dataValues;
+    private transient List<List<String>> dataKeys;
+    private transient List<List<String>> dataValues;
     private Integer entryIdx;
 
Index: trunk/src/org/openstreetmap/josm/gui/preferences/advanced/PreferencesTable.java
===================================================================
--- trunk/src/org/openstreetmap/josm/gui/preferences/advanced/PreferencesTable.java	(revision 8307)
+++ trunk/src/org/openstreetmap/josm/gui/preferences/advanced/PreferencesTable.java	(revision 8308)
@@ -43,5 +43,5 @@
 public class PreferencesTable extends JTable {
     private AllSettingsTableModel model;
-    private final List<PrefEntry> displayData;
+    private final transient List<PrefEntry> displayData;
 
     /**
Index: trunk/src/org/openstreetmap/josm/gui/preferences/advanced/StringEditor.java
===================================================================
--- trunk/src/org/openstreetmap/josm/gui/preferences/advanced/StringEditor.java	(revision 8307)
+++ trunk/src/org/openstreetmap/josm/gui/preferences/advanced/StringEditor.java	(revision 8308)
@@ -20,5 +20,5 @@
 public class StringEditor extends ExtendedDialog {
 
-    private PrefEntry entry;
+    private transient PrefEntry entry;
     private JosmTextField tvalue;
 
Index: trunk/src/org/openstreetmap/josm/gui/preferences/display/GPXSettingsPanel.java
===================================================================
--- trunk/src/org/openstreetmap/josm/gui/preferences/display/GPXSettingsPanel.java	(revision 8307)
+++ trunk/src/org/openstreetmap/josm/gui/preferences/display/GPXSettingsPanel.java	(revision 8308)
@@ -48,5 +48,5 @@
     private JRadioButton drawRawGpsLinesLocal = new JRadioButton(tr("Local files"));
     private JRadioButton drawRawGpsLinesNone = new JRadioButton(tr("None"));
-    private ActionListener drawRawGpsLinesActionListener;
+    private transient ActionListener drawRawGpsLinesActionListener;
     private JosmTextField drawRawGpsMaxLineLength = new JosmTextField(8);
     private JosmTextField drawRawGpsMaxLineLengthLocal = new JosmTextField(8);
Index: trunk/src/org/openstreetmap/josm/gui/preferences/display/LanguagePreference.java
===================================================================
--- trunk/src/org/openstreetmap/josm/gui/preferences/display/LanguagePreference.java	(revision 8307)
+++ trunk/src/org/openstreetmap/josm/gui/preferences/display/LanguagePreference.java	(revision 8308)
@@ -77,5 +77,5 @@
 
     private static class LanguageComboBoxModel extends DefaultComboBoxModel<Locale> {
-        private final List<Locale> data = new ArrayList<>();
+        private final transient List<Locale> data = new ArrayList<>();
 
         public LanguageComboBoxModel(){
Index: trunk/src/org/openstreetmap/josm/gui/preferences/imagery/AddImageryPanel.java
===================================================================
--- trunk/src/org/openstreetmap/josm/gui/preferences/imagery/AddImageryPanel.java	(revision 8307)
+++ trunk/src/org/openstreetmap/josm/gui/preferences/imagery/AddImageryPanel.java	(revision 8308)
@@ -30,5 +30,5 @@
     protected final JosmTextField name = new JosmTextField();
 
-    protected final Collection<ContentValidationListener> listeners = new ArrayList<>();
+    protected final transient Collection<ContentValidationListener> listeners = new ArrayList<>();
 
     /**
